/*-*- mode: c; coding: sjis-dos; -*-
 * $Id: z2h_inst.c,v 1.2 1999/12/28 18:52:47 tfuruka1 Exp $
 * $Log: z2h_inst.c,v $
 * Revision 1.2  1999/12/28 18:52:47  tfuruka1
 * ɕύXȂB[hC̕ύX̂݁B
 *
 * Revision 1.1  1997/04/18 14:20:26  furukawa
 * Initial revision
 *
 *
 * zen2han installer
 *      copyright 1997, By T.Furukawa
 *      HGA0016@niftyserve, tfuruka1@vdnet.or.jp
 *      tfuruka1@nsw.co.jp
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifndef UNIX
#       include <io.h>
#endif

#if defined(MSDOS) || defined(WIN32)
#       define PatchFileName    "zen2han.exe"
#elif defined(UNIX)
#       define PatchFileName    "zen2han"
#else
-DUNIX -DMSDOS -DWIN32 ̉ꂩRpCIvVɎw肵ĉ
#endif

char *DefFile = "zen2han.def";

void usage(char *str)
{
    fprintf(stderr, "usage : %s InstallDirectory\n", str);
    exit(1);
}

void CopyFileBin(char *From, char *To)
{
    FILE *Ffp, *Tfp;
    int c;

    printf("%s ---> %s", From, To);
    fflush(stdout);
    if (NULL == (Ffp = fopen(From, "rb"))) {
        perror(From);
        exit(1);
    }
    if (NULL == (Tfp = fopen(To, "wb"))) {
        perror(To);
        exit(1);
    }

    while (EOF != (c = getc(Ffp))) {
        putc(c, Tfp);
    }
    fclose(Tfp);
    fclose(Ffp);
    printf("  ...done\n");
}

static int SameCheck(char *Path, char *Base)
{
    char Buf[256];
    struct stat StatBuf, StatBuf1;

    memset(&StatBuf, '\0', sizeof(struct stat));
    memset(&StatBuf1, '\0', sizeof(struct stat));

    sprintf(Buf, "%s/%s", Path, Base);
    if (-1 == stat(Buf, &StatBuf)) {
        return 0;
    }
    if (-1 == stat(Base, &StatBuf1)) {
        perror(Base);
        exit(1);
    }
    if (0 == memcmp(&StatBuf, &StatBuf1, sizeof(struct stat))) {
        printf("fBNgƃCXg[fBNgƐ"
               "܂̂ŁARs[͍s܂B\n");
        return 1;
    }
    return 0;
}

int main(int argc, char *argv[])
{
    struct stat StatBuf;
    static char *Key = "-*-Patch-*-";
    char Reserve[256], FileName[16], BackUpFile[16], *p;
    FILE *InFp, *OutFp;
    int c, idx = 0, i, Success = 0;

    if (2 != argc) {
        usage(argv[0]);
    }

    if (-1 == stat(argv[1], &StatBuf)) {
        perror(argv[1]);
        return 1;
    }
    if (!(StatBuf.st_mode & S_IFDIR)) {
        fprintf(stderr, "'%s' is not directory\n");
        return 1;
    }

    strcpy(BackUpFile,strcpy(FileName, PatchFileName));

    if (0 != access(FileName, 0)) {
        perror(FileName);
        return 1;
    }

    if (NULL == (p = strrchr(BackUpFile, '.'))) {
        strcat(BackUpFile, ".bak");
    } else {
        strcpy(p, ".bak");
    }
    unlink(BackUpFile);

    if (-1 == rename(FileName, BackUpFile)) {
        perror(FileName);
    }
    if (NULL == (InFp = fopen(BackUpFile, "rb"))) {
        perror(FileName);
        return 1;
    }
    if (NULL == (OutFp = fopen(FileName, "wb"))) {
        perror(FileName);
        return 1;
    }
    printf("%s 𐶐ł...", FileName);
    fflush(stdout);
    while (EOF != (c = getc(InFp))) {
        if ((int)*(Key + idx) == c) {
            Reserve[idx++] = (char)c;
            putc(c, OutFp);
            if ('\0' != c) continue;
            printf("Found keyword\n");
            for (i = idx; i < 16; i++) putc(getc(InFp), OutFp);
            for (i = 0; i < (int)strlen(argv[1]); i++) { /* copy path name */
                getc(InFp);
                putc(*(argv[1] + i), OutFp);
            }
            getc(InFp); putc('/', OutFp); /* Directory separater */
            for (i = 0; i <= (int)strlen(DefFile); i++) { /* deffilne & NULL */
                getc(InFp);
                putc(*(DefFile + i), OutFp);
            }
            idx = 0;
            Success++;
            continue;
        }
        idx = 0;
        putc(c, OutFp);
    }
    fclose(InFp);
    fclose(OutFp);

    if (!Success) {
        fprintf(stderr, " %s 𐶐o܂łB\n", FileName);
        return 1;
    }
    printf("\n");

    if (!SameCheck(argv[1], FileName)) {
        sprintf(Reserve, "%s/%s", argv[1], DefFile);
        CopyFileBin(DefFile, Reserve);
        sprintf(Reserve, "%s/%s", argv[1], FileName);
        CopyFileBin(FileName, Reserve);
    }

#if defined(UNIX)
    sprintf(Reserve, "%s/%s", argv[1], FileName);
    if (-1 == chmod(Reserve,
                    S_IRWXU |
                    S_IRUSR | S_IXUSR |
                    S_IROTH | S_IXOTH)){
        perror("chmod");
    }
#endif
    printf("CXg[͊܂\n");
    return 0;
}
